package betterwithmods.manual.client.manual.segment;

import betterwithmods.manual.api.manual.ImageRenderer;
import betterwithmods.module.compat.jei.JEI;
import com.google.common.base.Strings;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;

public class JEIRenderSegment extends RenderSegment {


    private final String recipeOutput;

    public JEIRenderSegment(Segment parent, String title, String recipeOutput, ImageRenderer imageRenderer) {
        super(parent, title, imageRenderer);
        this.recipeOutput = recipeOutput;
    }

    @Override
    public boolean onMouseClick(final int mouseX, final int mouseY) {
        if (JEI.JEI_RUNTIME != null && recipeOutput != null) {
            ItemStack stack = getStack(recipeOutput);
            JEI.showRecipe(stack);
            return true;
        }
        return false;
    }

    public ItemStack getStack(String data) {
        data = data.substring(data.indexOf(":") + 1);
        final int splitIndex = data.lastIndexOf('@');
        final String name, optMeta;
        if (splitIndex > 0) {
            name = data.substring(0, splitIndex);
            optMeta = data.substring(splitIndex);
        } else {
            name = data;
            optMeta = "";
        }
        final int meta = (Strings.isNullOrEmpty(optMeta)) ? 0 : Integer.parseInt(optMeta.substring(1));
        final Item item = Item.field_150901_e.func_82594_a(new ResourceLocation(name));
        if (item == null)
            return ItemStack.field_190927_a;
        return new ItemStack(item, 1, meta);
    }


}
